<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/28/2003 *
 * ===============                              Last change: 08/18/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_user.php                               *
 * -------------------------------------------------------------------- *
 * Short description : List all or partial members                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle oder nur bestimmte Mitglieder auflisten     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if ((!isExtensionInstalled('user')) || (!isExtensionActive('user'))) {
	// Missing extension!
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('user'));
	return;
} // END - if

// Init variables
$MORE = '';
$colspan = 4;

// Add nickname if extension is found&active
// @TODO Rewrite these if-blocks in a filter
if (isExtensionActive('nickname')) {
	// Add nickname
	$MORE .= ", `nickname`";
} else {
	$MORE .= ", `userid`";
}

// Add random confirmed if extension version matches
if (getExtensionVersion('user') >= '0.3.4') {
	// Add it...
	$MORE .= ", `rand_confirmed`";

	// Add lock reason?
	if (getExtensionVersion('user') >= '0.3.5') {
		// Add them...
		$MORE .= ", `lock_reason`, UNIX_TIMESTAMP(`lock_timestamp`) AS lock_timestamp";
	} // END - if
} // END - if

// Is the extension 'country' installed?
if (isExtensionActive('country')) {
	// Add country code
	$MORE .= ", `country_code`";
} else {
	// Add direct value
	$MORE .= ", `country`";
}

// Init unset data
if (!isGetRequestElementSet('letter')) { setRequestGetElement('letter', getMessage('_ALL2')); }
if (!isGetRequestElementSet('sortby')) { setRequestGetElement('sortby', 'userid');            }
if (!isGetRequestElementSet('page'))   { setRequestGetElement('page'  , 1);                 }

// Set base URL
$base = '[<a href="{?URL?}/modules.php?module=admin';

if (isGetRequestElementSet('userid')) {
	// Secure the user id
	$userid = bigintval(getRequestElement('userid'));

	// Does the account exists?
	$result_user = SQL_QUERY_ESC("SELECT
	`gender`, `surname`, `family`, `street_nr`, `zip`, `city`, `country`, `email`, `birth_day`, `birth_month`, `birth_year`, `max_mails`, `receive_mails`, `refid`, `status`, `REMOTE_ADDR`, `last_online`, `last_module`, `ref_clicks`, `total_logins`, `used_points`, `emails_sent`, `joined`, `last_update`, `last_profile_sent`, `notified`, `ref_payout`, `emails_received`, `mails_confirmed`".$MORE."
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	`userid`=%s
LIMIT 1",
		array($userid), __FILE__, __LINE__);

	// User found?
	if (SQL_NUMROWS($result_user) == 1) {
		// Account found!
		$content  = SQL_FETCHARRAY($result_user);

		// Get count/sum of refs, selected categories, unconfirmed mails
		$content['refs']  = countSumTotalData($userid, 'refsystem' , 'counter');
		$content['cats']  = countSumTotalData($userid, 'user_cats' , 'id', 'userid', true);
		$content['links'] = countSumTotalData($userid, 'user_links', 'id', 'userid', true);

		// Add links to the numbers
		if ($content['links'] > 0) $content['links'] = $base . '&amp;what=list_links&amp;userid=' . $userid . '">' . $content['links'] . '</a>]';
		if ($content['refid'] > 0) $content['refid'] = $base . '&amp;what=list_user&amp;userid=' . $content['refid'] . '">'.$content['refid'] . '</a>]';
		if ($content['refs']  > 0) $content['refs']  = $base . '&amp;what=list_refs&amp;userid=' . $userid . '">' . $content['refs'] . '</a>]';
		if ($content['cats']  > 0) $content['cats']  = $base . '&amp;what=list_cats&amp;userid=' . $userid . '">' . $content['cats'] . '</a>]';

		// Fix empty module
		if (empty($content['last_module'])) $content['last_module'] = '---';

		// Calculate timestamp for birthday
		$stamp = mktime(0, 0, 0, $content['birth_month'], $content['birth_day'], $content['birth_year']);

		// Is this above zero?
		if ($stamp > 0) {
			// Then use it
			$content['birthday'] = generateDateTime($stamp, 3);
		} else {
			// Zero or below so set zero!
			$content['birthday'] = generateDateTime(0, 3);
		}

		// Prepare data for template
		$content['admin_links']       = generateMemberAdminActionLinks($userid, $content['status']);
		$content['gender']            = translateGender($content['gender']);
		$content['email_link']        = generateEmailLink($content['email'], 'user_data');
		$content['status']            = translateUserStatus($content['status']);
		$content['last_online']       = generateDateTime($content['last_online'], 0);
		$content['used_points']       = translateComma($content['used_points']);
		if ($content['emails_sent'] > 0) $content['emails_sent'] = $base . '&amp;what=email_details&amp;userid=' . $userid . '">' . translateComma($content['emails_sent']) . '</a>]';
		$content['joined']            = generateDateTime($content['joined'], 0);
		$content['last_update']       = generateDateTime($content['last_update'], 0);
		$content['last_profile_sent'] = generateDateTime($content['last_profile_sent'], 0);
		$content['total']             = translateComma(countSumTotalData($userid, 'user_points', 'points'));
		$content['locked']            = translateComma(countSumTotalData($userid, 'user_points', 'locked_points'));
		$content['lock_timestamp']    = generateDateTime($content['lock_timestamp'], 2);

		// Is the lock reason not set?
		if (!isset($content['lock_reason'])) $content['lock_reason'] = '---';

		// Nickname inclusion?
		// @TODO Rewrite these to filters
		if (isExtensionActive('nickname')) {
			// Nickname not set or invalid? Then
			if ((empty($content['nickname'])) || ($content['nickname'] == $userid)) $content['nickname'] = '---';
		} else {
			// Extension not found
			$content['nickname'] = getMessage('EXT_NICKNAME_404');
		}

		// Is the user extension newer?
		if (getExtensionVersion('user') >= '0.3.4') {
			// Then "translate" the number
			$content['rand_confirmed'] = translateComma($content['rand_confirmed']);
		} // END - if

		// Clickrate
		$content['click_rate'] = '0';
		if ($content['emails_received'] > 0) {
			$content['click_rate'] = translateComma($content['mails_confirmed'] / $content['emails_received'] * 100);
		} // END - if

		// "Translate" more data
		$content['mails_confirmed'] = translateComma($content['mails_confirmed']);
		$content['emails_received'] = translateComma($content['emails_received']);

		// Is the extension 'country' installed?
		if (isExtensionActive('country')) {
			// Then overwrite country information
			$content['country'] = generateCountryInfo($content['country_code']);
		} elseif ($content['country'] == '0') {
			// Zero id???
			$content['country'] = '???';
		}

		// Add userid
		$content['userid'] = $userid;

		// Load user-details template
		loadTemplate('admin_user_details', false, $content);
	} else {
		// Account does not exist!
		loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_MEMBER_404'), $userid));
	}

	// Free the result
	SQL_FREERESULT($result_user);
} else {
	$whereStatement = '';
	if ((getRequestElement('letter') != getMessage('_ALL2')) && (getRequestElement('letter') != getMessage('_OTHERS')) && (isGetRequestElementSet('letter'))) {
		// List only persons w
		$whereStatement = " WHERE `family` LIKE '".getRequestElement('letter') . "%'";
	} // END - if

	// Parse the status or mode parameter
	if (isGetRequestElementSet(('status'))) {
		// Is a WHERE statement already there?
		if (!empty($whereStatement)) {
			// Then append the status column
			$whereStatement .= sprintf(" AND `status`='%s'", SQL_ESCAPE(secureString(strtoupper(getRequestElement('status')))));
		} else {
			// Start a new one
			$whereStatement = sprintf(" WHERE `status`='%s'", SQL_ESCAPE(secureString(strtoupper(getRequestElement('status')))));
		}
	} elseif (isGetRequestElementSet('mode')) {
		// Choose what we need to list
		switch (getRequestElement('mode')) {
			case 'norefs': // Users w/o refs
				if (!empty($whereStatement)) {
					// Add AND statement
					$whereStatement .= " AND `refid`=0";
				} else {
					// Add WHERE statement
					$whereStatement = " WHERE `refid`=0";
				}
				break;

			default: // Invalid list mode
				logDebugMessage(__FILE__, __LINE__, sprintf("Invalid list mode %s detected.", getRequestElement('mode')));
				break;
		} // END - switch
	} // END - if

	// Generate master query string
	$sql = sprintf("SELECT `userid`, `gender`, `surname`, `family`, `email`, `REMOTE_ADDR`, `refid`, `status`, `emails_sent`, `mails_confirmed`, `emails_received`" . $MORE . " FROM `{?_MYSQL_PREFIX?}_user_data`" . $whereStatement . " ORDER BY `%s` ASC",
		getRequestElement('sortby')
	);

	// Prepare SQL and run it
	$result_master = SQL_QUERY($sql, __FILE__, __LINE__);

	// Calculate page count (0.5 fixes a bug with page count)
	if (getConfig('user_limit') == '0') {
		setConfigEntry('user_limit', 100);
		loadTemplate('admin_settings_saved', false, getMessage('EXTENSION_WARNING_USER_LIMIT'));
	} // END - if

	// Activate the extension please!
	$PAGES = round(SQL_NUMROWS($result_master) / getConfig('user_limit') + 0.5);

	if (!isGetRequestElementSet('page'))   setRequestGetElement('page'  , 1);
	if (!isGetRequestElementSet('offset')) setRequestGetElement('offset', getConfig('user_limit'));

	// Add limitation to SQL string and run him again
	$sql .= " LIMIT ".(getRequestElement('offset') * getRequestElement('page') - getRequestElement('offset')).", ".getRequestElement('offset');
	$result = SQL_QUERY($sql, __FILE__, __LINE__);

	// Count all confirmed users
	$user_count = countSumTotalData('CONFIRMED','user_data','userid','status',true);

	// Are there some entries?
	if (SQL_NUMROWS($result_master) > 0) {
		// We have some (new?) registrations!
		define('__COLSPAN2'  , ($colspan + 2));
		define('__USER_CNT'  , $user_count);

		// Sorting links
		define('__ALPHA_SORT', alpha(getRequestElement('sortby'), $colspan, true));
		define('__SORT_LINKS', addSortLinks(getRequestElement('letter'), getRequestElement('sortby'), $colspan, true));

		if ($PAGES > 1) {
			define('__PAGE_NAV', addPageNavigation($PAGES, getConfig('user_limit'), true, $colspan, true));
		} else {
			// No page navigation is required
			define('__PAGE_NAV', '');
		}

		// Column with nickname when nickname extension is present
		// @TODO Rewrite this into a  filter
		if (isExtensionActive('nickname')) {
			// Nickname extension found
			define('__NICKNAME_TH', "  <td class=\"admin_title bottom2\" align=\"center\">{--NICKNAME--}</td>");
		} else {
			// Not found
			define('__NICKNAME_TH', '');
		}

		// Load all users
		$OUT = ''; $SW = 2;
		while ($content = SQL_FETCHARRAY($result)) {
			// Set refid link
			if ($content['refid'] > 0) $content['refid'] = generateUserProfileLink($content['refid']);

			// Get number of unconfirmed mails
			$content['links'] = countSumTotalData($content['userid'], 'user_links', 'id', 'userid', true);
			if ($content['links'] > 0) $content['links'] = $base . '&amp;what=list_links&amp;userid=' . $content['userid'] . '">' . translateComma($content['links']) . '</a>]';

			// Set link to sent mails if present
			if ($content['emails_sent'] > 0) $content['emails_sent'] = $base . '&amp;what=email_details&amp;userid=' . $content['userid'] . '">' . translateComma($content['emails_sent']) . '</a>]';

			// Add nickname
			if ((empty($content['nickname'])) || ($content['nickname'] == $content['userid'])) $content['nickname'] = '---';

			// Calculate total points
			$pointsTotal = countSumTotalData($content['userid'], 'user_points', 'points')  - countSumTotalData($content['userid'], 'user_data', 'used_points');

			// Clickrate
			$clickRate = '0';
			if ($content['emails_received'] > 0) {
				$clickRate = $content['mails_confirmed'] / $content['emails_received'] * 100;
			} // END - if

			// Transfer data to array
			$content['sw']             = $SW;
			$content['userid_link']    = generateUserProfileLink($content['userid']);
			$content['gender']         = translateGender($content['gender']);
			$content['email']          = '[<a href="' . generateEmailLink($content['email'], 'user_data') . '">' . $content['email'] . '</a>]';
			$content['alinks']         = generateMemberAdminActionLinks($content['userid'], $content['status']);
			$content['points']         = translateComma($pointsTotal);
			$content['rate']           = translateComma($clickRate);
			$content['locked']         = translateComma(countSumTotalData($content['userid'], 'user_points', 'locked_points'));
			$content['lock_timestamp'] = generateDateTime($content['lock_timestamp'], 2);
			$content['status']         = translateUserStatus($content['status']);
			$content['refs']           = countSumTotalData($content['userid'], 'user_refs', 'id', 'userid', true);

			// If we have at least one referal, make it clickable to referal list
			if ($content['refs'] > 0) $content['refs'] = $base . '&amp;what=list_refs&amp;userid=' . $content['userid'] . '">' . $content['refs'] . '</a>]';

			// Is the lock reason not set?
			if (!isset($content['lock_reason'])) $content['lock_reason'] = '---';

			// Is the extension 'country' installed?
			// @TODO Rewrite this into a filter
			if (isExtensionActive('country')) {
				// Then overwrite country information
				$content['country'] = generateCountryInfo($content['country_code']);
			} elseif ($content['country'] == '') {
				// Zero id???
				$content['country'] = '???';
			}

			// Load row template and switch colors
			$OUT .= loadTemplate('admin_list_user_row', true, $content);
			$SW = 3 - $SW;
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Free some memory
		SQL_FREERESULT($result_master);

		// Remember all rows
		$content['rows'] = $OUT;

		// Init title with "all accounts"
		$content['title'] = getMessage('ADMIN_ALL_ACCOUNTS');
		if (isGetRequestElementSet(('status'))) {
			// Set title according to the 'status'
			$content['title'] = getMessage(sprintf("ADMIN_LIST_STATUS_%s_ACCOUNTS", strtoupper(getRequestElement(('status')))));
		} elseif (isGetRequestElementSet('mode')) {
			// Set title according to the "mode"
			$content['title'] = getMessage(sprintf("ADMIN_LIST_MODE_%s_ACCOUNTS", strtoupper(getRequestElement('mode'))));
		}

		// Load main template
		loadTemplate('admin_list_user', false, $content);
	} else {
		// No one as registered so far! :-(
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_NO_NONE_REGISTERED'));
	}

	// Free memory
	SQL_FREERESULT($result_master);
}

// [EOF]
?>
